#include <sys/types.h>
#include <sys/poll.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/select.h>
#include <unistd.h>
#include <iostream>
#include <cstring>

using namespace std;

int main ()
{
    int sock, client;
    sockaddr_in addr, client_addr;
    size_t size;

    sock = socket (PF_INET, SOCK_STREAM, 0);

    memset (&addr, 0, sizeof (addr));
    addr.sin_family = PF_INET;
    addr.sin_port = htons (9000);
    addr.sin_addr.s_addr = htonl (INADDR_ANY);
    if (bind (sock, (struct sockaddr *) &addr, sizeof(struct sockaddr)))
    {
        perror ("Problem z funkcja bind");
        return 1;
    }

    listen (sock, 10);
    size = sizeof (client_addr);
    cout << "Czekam na polaczenie sieciowe na porcie 9000 ..." << endl;
    client = accept (sock, (struct sockaddr *) &client_addr, &size);

    struct pollfd ufds[2];

    ufds[0].fd = 0;
    ufds[0].events = POLLIN;
    ufds[1].fd = client;
    ufds[1].events = POLLIN;

    cout << "start" << endl;
    int event = poll (ufds, 2, 5000);
    cout << "stop" << endl;

    if (event > 0)
    {
        char buf;
        if (ufds[0].revents & POLLIN)
        {
            read (0, &buf, 1);
            cout << "Odczytano ze standardowego wejscia znak: " << buf << endl;
        }
        else if (ufds[1].revents & POLLIN)
        {
            read (client, &buf, 1);
            cout << "Odczytano z sieci znak: " << buf << endl;
        }
    } 
    else if (event < 0)
        cout << "Blad!" << endl;
    else
        cout << "Nie odczytano" << endl;

    return 0;
}
